# DO NOT EDIT this file by hand!
# It is generated from corresponding Open API schema.
# Visit `yaookctl/commands/generate/model.py` for further details.

# generated by datamodel-codegen:
#   filename:  <stdin>

from __future__ import annotations

from typing import List, Optional

from pydantic import BaseModel, Field


class CertManager(BaseModel):
    enabled: Optional[bool] = False
    install: Optional[bool] = None
    letsencrypt_email: Optional[str] = None
    letsencrypt_ingress: Optional[str] = None
    letsencrypt_preferred_chain: Optional[str] = None
    namespace: Optional[str] = None
    scheduling_key: Optional[str] = None


class EtcdBackup(BaseModel):
    bucket_name: Optional[str] = None
    chart_version: Optional[str] = None
    days_of_retention: Optional[int] = None
    enabled: Optional[bool] = None
    file_prefix: Optional[str] = None
    s3_config_name: Optional[str] = None
    schedule: Optional[str] = None


class Ingress(BaseModel):
    enable_ssl_passthrough: Optional[bool] = None
    enabled: Optional[bool] = False
    install: Optional[bool] = None
    namespace: Optional[str] = None
    nodeport_http: Optional[int] = None
    nodeport_https: Optional[int] = None
    scheduling_key: Optional[str] = None
    service_type: Optional[str] = None


class CommonLabels(BaseModel):
    managed_by: Optional[str] = Field(None, alias='managed-by')


class InternetProbeTarget(BaseModel):
    interval: Optional[str] = None
    module: Optional[str] = None
    name: Optional[str] = None
    scrapeTimeout: Optional[str] = None
    url: Optional[str] = None


class Prometheus(BaseModel):
    alertmanager_cpu_limit: Optional[str] = None
    alertmanager_cpu_request: Optional[str] = None
    alertmanager_memory_limit: Optional[str] = None
    alertmanager_memory_request: Optional[str] = None
    common_labels: Optional[CommonLabels] = None
    grafana_cpu_limit: Optional[str] = None
    grafana_cpu_request: Optional[str] = None
    grafana_memory_limit: Optional[str] = None
    grafana_memory_request: Optional[str] = None
    grafana_persistent_storage_class: Optional[str] = None
    install: Optional[bool] = None
    internet_probe: Optional[bool] = None
    internet_probe_targets: Optional[List[InternetProbeTarget]] = None
    kube_state_metrics_cpu_limit: Optional[str] = None
    kube_state_metrics_cpu_request: Optional[str] = None
    kube_state_metrics_memory_limit: Optional[str] = None
    kube_state_metrics_memory_request: Optional[str] = None
    migrate_from_v1: Optional[bool] = None
    namespace: Optional[str] = None
    prometheus_cpu_limit: Optional[str] = None
    prometheus_cpu_request: Optional[str] = None
    prometheus_memory_limit: Optional[str] = None
    prometheus_memory_request: Optional[str] = None
    prometheus_monitor_all_namespaces: Optional[bool] = None
    prometheus_stack_version: Optional[str] = None
    scheduling_key: Optional[str] = None
    thanos_metadata_volume_size: Optional[str] = None
    thanos_metadata_volume_storage_class: Optional[str] = None
    thanos_objectstorage_container_name: Optional[str] = None
    thanos_query_cpu_limit: Optional[str] = None
    thanos_query_cpu_request: Optional[str] = None
    thanos_query_memory_limit: Optional[str] = None
    thanos_query_memory_request: Optional[str] = None
    thanos_sidecar_cpu_limit: Optional[str] = None
    thanos_sidecar_cpu_request: Optional[str] = None
    thanos_sidecar_memory_limit: Optional[str] = None
    thanos_sidecar_memory_request: Optional[str] = None
    thanos_store_cpu_limit: Optional[str] = None
    thanos_store_cpu_request: Optional[str] = None
    thanos_store_memory_limit: Optional[str] = None
    thanos_store_memory_request: Optional[str] = None
    use_grafana: Optional[bool] = None
    use_jsonnet_setup: Optional[bool] = None
    use_thanos: Optional[bool] = None


class Pool(BaseModel):
    create_storage_class: Optional[str] = None
    name: Optional[str] = None
    replicated: Optional[int] = None


class Rook(BaseModel):
    ceph_fs: Optional[bool] = None
    ceph_fs_name: Optional[str] = None
    ceph_fs_preserve_pools_on_delete: Optional[bool] = None
    ceph_fs_replicated: Optional[int] = None
    cluster_name: Optional[str] = 'rook-ceph'
    csi_plugins: Optional[bool] = None
    encrypt_osds: Optional[bool] = None
    mds_cpu_limit: Optional[str] = None
    mds_cpu_request: Optional[str] = None
    mds_memory_limit: Optional[str] = None
    mds_memory_request: Optional[str] = None
    mgr_cpu_limit: Optional[str] = None
    mgr_cpu_request: Optional[str] = None
    mgr_memory_limit: Optional[str] = None
    mgr_memory_request: Optional[str] = None
    mgr_scheduling_key: Optional[str] = None
    mon_cpu_limit: Optional[str] = None
    mon_cpu_request: Optional[str] = None
    mon_memory_limit: Optional[str] = None
    mon_memory_request: Optional[str] = None
    mon_scheduling_key: Optional[str] = None
    mon_volume_storage_class: Optional[str] = None
    namespace: Optional[str] = 'rook-ceph'
    nmgrs: Optional[int] = None
    nmons: Optional[int] = None
    nodeplugin_toleration: Optional[bool] = None
    nosds: Optional[int] = None
    operator_cpu_limit: Optional[str] = None
    operator_cpu_request: Optional[str] = None
    osd_cpu_limit: Optional[str] = None
    osd_cpu_request: Optional[str] = None
    osd_memory_limit: Optional[str] = None
    osd_memory_request: Optional[str] = None
    osd_volume_size: Optional[str] = None
    pools: Optional[List[Pool]] = None
    scheduling_key: Optional[str] = None
    skip_upgrade_checks: Optional[bool] = None
    toolbox: Optional[bool] = None
    use_host_networking: Optional[bool] = None
    version: Optional[str] = None


class Vault(BaseModel):
    chart_version: Optional[str] = None
    dnsnames: Optional[List[str]] = None
    enabled: Optional[bool] = None
    init_key_shares: Optional[int] = None
    init_key_threshold: Optional[int] = None
    management_cluster_integration: Optional[bool] = None
    namespace: Optional[str] = None
    scheduling_key: Optional[str] = None
    storage_class: Optional[str] = None
    storage_size: Optional[str] = None


class K8sServiceLayer(BaseModel):
    cert_manager: Optional[CertManager] = Field(None, alias='cert-manager')
    etcd_backup: Optional[EtcdBackup] = Field(None, alias='etcd-backup')
    ingress: Optional[Ingress] = None
    prometheus: Optional[Prometheus] = None
    rook: Optional[Rook] = None
    vault: Optional[Vault] = None


class Spec(BaseModel):
    clusterName: str
    k8s_service_layer: Optional[K8sServiceLayer] = Field(
        None, alias='k8s-service-layer'
    )


class Status(BaseModel):
    failureMessage: Optional[str] = None
    failureReason: Optional[str] = None
    phase: Optional[str] = None
    ready: Optional[bool] = None


class Metadata(BaseModel):
    name: Optional[str] = None
    namespace: Optional[str] = None


class YaookService(BaseModel):
    spec: Spec
    status: Optional[Status] = None
    metadata: Optional[Metadata] = None
